     h dftactgrp(*no) actgrp(*caller)
     h debug(*yes) alwnull(*inputonly)
     h bnddir('QC2LE')
      *
      **************************************************************************
      * Data structures & fields
      **************************************************************************
      *
     d vApiErrDs       ds
     d  vbytpv                       10i 0 inz(%len(vApiErrDs))                 bytes provided
     d  vbytav                       10i 0 inz(0)                               bytes returned
     d  vmsgid                        7a                                        error msgid
     d  vresvd                        1a                                        reserved
     d  vrpldta                     128a                                        replacement data
      *
     D mMsgRtv         ds                  inz
     D mMsgRtvLen              9     12i 0                                      length msg retrieved
     D mMsgMessage            25    256                                         message retrieved
      *
     D mMsgLen         s             10i 0 inz(%len(mMsgRtv))                   length of message
     d  Msgmic         s              7a
     d  Msgfil         s             20a
     d  MsgDta         s          32767a
     d  MsgLen         s             10i 0
     d  Msgtyp         s             10a
     d  Msgpgq         s             10a
     d  Msgstk         s             10i 0
     d  Msgkey         s              4a
      *
     d  SpaceName      s             20a   Inz('SNDSPLF   QTEMP')
     d  ExtAttr        s             10    Inz(*blanks)
     d  InitSize       s             10i 0 Inz(32000)
     d  InitVal        s              1    Inz(X'00')
     d  Auth           s             10    Inz('*ALL')
     d  Text           s             50    Inz('Spooled File Data')
     d  Replace        s             10    Inz('*YES')
      *
     d  SpoolNbr       s             10i 0
      *
     d  Handle1        s             10i 0 Inz(*zeros)
     d  Handle2        s             10i 0 Inz(*zeros)
      *
     d  BufferReturn   s             10i 0
      *
     d  EndOfFile      s               n   Inz(*off)
     D*****************************************************************
     D*Record structure for USRI0100 format
     D*****************************************************************
     DQSYI0100         DS
     D*                                             Qsy USRI0100
     D QSYBRTN00               1      4i 0
     D*                                             Bytes Returned
     D QSYBAVL00               5      8i 0
     D*                                             Bytes Available
     D QSYUP01                 9     18
     D*                                             User Profile
     D******************************************************************
     D*Record structure for QUSRJOBI JOBI0400 format
     D******************************************************************
     DQUSI0400         DS
     D*                                             Qwc JOBI0400
     D QUSBR03                 1      4i 0
     D*                                             Bytes Return
     D QUSBA03                 5      8i 0
     D*                                             Bytes Avail
     D QUSJN06                 9     18
     D*                                             Job Name
     D QUSUN05                19     28
     D*                                             User Name
     D QUSJNBR05              29     34
     D*                                             Job Number
      *
     D****************************************************************
     D*Structure for SPLA0200 format
     D****                                                           *
     D*NOTE:  The following type definition only defines the fixed
     D*    portion of the format.  Any varying length fields must
     D*    be defined by the user.
     D****************************************************************
     DQUSA0200         DS
     D*                                             Qus SPLA0200
     D QUSBR08                 1      4i 0
     D*                                             Bytes Return
     D QUSBA08                 5      8i 0
     D*                                             Bytes Avail
     D QUSFN18                 9     16
     D*                                             Format Name
     D QUSIJID09              17     32
     D*                                             Int Job ID
     D QUSISID01              33     48
     D*                                             Int Splf ID
     D QUSJN11                49     58
     D*                                             Job Name
     D QUSUN13                59     68
     D*                                             Usr Name
     D QUSJNBR10              69     74
     D*                                             Job Number
     D QUSSN02                75     84
     D*                                             Splf Name
     D QUSSNBR00              85     88i 0
     D*                                             Splf Number
     D QUSFT03                89     98
     D*                                             Form Type
     D QUSUD02                99    108
     D*                                             Usr Data
     D QUSTATUS05            109    118
     D*                                             Status
     D QUSFILA04             119    128
     D*                                             File Avail
     D QUSHFIL00             129    138
     D*                                             Hold File
     D QUSSFIL04             139    148
     D*                                             Save File
     D QUSTP00               149    152i 0
     D*                                             Total Pages
     D QUSCP01               153    156i 0
     D*                                             Curr Page
     D QUSSP00               157    160i 0
     D*                                             Start Page
     D QUSEP00               161    164i 0
     D*                                             End Page
     D QUSLPP00              165    168i 0
     D*                                             Last Page Print
     D QUSRP03               169    172i 0
     D*                                             Rest Page
     D QUSTC00               173    176i 0
     D*                                             Total Copies
     D QUSCR00               177    180i 0
     D*                                             Copies Rem
     D QUSLPI00              181    184i 0
     D*                                             Lines Per Inch
     D QUSCPI00              185    188i 0
     D*                                             Char Per Inch
     D QUSOP02               189    190
     D*                                             Output Priority
     D QUSON01               191    200
     D*                                             Outq Name
     D QUSOL01               201    210
     D*                                             Outq Lib
     D QUSDFILO00            211    217
     D*                                             Date File Open
     D QUSTFILO00            218    223
     D*                                             Time File Open
     D QUSDFILN03            224    233
     D*                                             Dev File Name
     D QUSDFILL03            234    243
     D*                                             Dev File Lib
     D QUSPN00               244    253
     D*                                             Pgm Name
     D QUSPL02               254    263
     D*                                             Pgm Lib
     D QUSCC02               264    278
     D*                                             Count Code
     D QUSPT01               279    308
     D*                                             Print Text
     D QUSRL06               309    312i 0
     D*                                             Record Length
     D QUSMR00               313    316i 0
     D*                                             Max Records
     D QUSDT01               317    326
     D*                                             Dev Type
     D QUSPDT00              327    336
     D*                                             Ptr Dev Type
     D QUSDN01               337    348
     D*                                             Doc Name
     D QUSFN19               349    412
     D*                                             Folder Name
     D QUSS36PN00            413    420
     D*                                             S36 Proc Name
     D QUSPF01               421    430
     D*                                             Print Fidel
     D QUSRU00               431    431
     D*                                             Repl Unprint
     D QUSRC01               432    432
     D*                                             Repl Char
     D QUSPL03               433    436i 0
     D*                                             Page Length
     D QUSPW00               437    440i 0
     D*                                             Page Width
     D QUSNBRS02             441    444i 0
     D*                                             Number Separate
     D QUSOLN00              445    448i 0
     D*                                             Overflow Line Nm
     D QUSDBCSD00            449    458
     D*                                             DBCS Data
     D QUSBCSEC00            459    468
     D*                                             DBCS Ext Chars
     D QUSSSOSI00            469    478
     D*                                             DBCS SOSI
     D QUSBCSCR00            479    488
     D*                                             DBCS Char Rotate
     D QUSDBCSC01            489    492i 0
     D*                                             DBCS Cpi
     D QUSGCS00              493    502
     D*                                             Grph Char Set
     D QUSCP02               503    512
     D*                                             Code Page
     D QUSFDN00              513    522
     D*                                             Form Def Name
     D QUSFDL00              523    532
     D*                                             Form Def Lib
     D QUSSD07               533    536i 0
     D*                                             Source Drawer
     D QUSPF02               537    546
     D*                                             Print Font
     D QUS36SID00            547    552
     D*                                             S36 Spl ID
     D QUSPR00               553    556i 0
     D*                                             Page Rotate
     D QUSATION00            557    560i 0
     D*                                             Justification
     D QUSUPLEX00            561    570
     D*                                             Duplex
     D QUSFOLD00             571    580
     D*                                             Fold
     D QUSCC03               581    590
     D*                                             Ctrl Char
     D QUSAF00               591    600
     D*                                             Align Forms
     D QUSPQ00               601    610
     D*                                             Print Quality
     D QUSFF00               611    620
     D*                                             Form Feed
     D QUSDV00               621    691
     D*                                             Disk Volume
     D QUSDL01               692    708
     D*                                             Disk Label
     D QUSET00               709    718
     D*                                             Exch Type
     D QUSCC04               719    728
     D*                                             Char Code
     D QUSNDR00              729    732i 0
     D*                                             Nmbr Disk Rcrds
     D QUSLTIUP00            733    736i 0
     D*                                             Multiup
     D QUSFON00              737    746
     D*                                             Frnt Ovrly Name
     D QUSFOLN00             747    756
     D*                                             Frnt Ovrly Lib Name
     D QUSFOOD00             757    764P 5
     D*                                             Frnt Ovrly Off Dn
     D QUSFOOA00             765    772P 5
     D*                                             Frnt Ovrly Off Across
     D QUSBON00              773    782
     D*                                             Bck Ovrly Name
     D QUSBOLN00             783    792
     D*                                             Bck Ovrly Lib Name
     D QUSBOOD00             793    800P 5
     D*                                             Bck Ovrly Off Dn
     D QUSBOOA00             801    808P 5
     D*                                             Bck Ovrly Off Across
     D QUSUM00               809    818
     D*                                             Unit Measure
     D QUSPD04               819    828
     D*                                             Page Definition
     D QUSPDL00              829    838
     D*                                             Page Definition Lib
     D QUSLS01               839    848
     D*                                             Line Spacing
     D QUSPS00               849    856P 5
     D*                                             Point Size
     D QUSMDRS               857    860i 0
     D*                                             Max Data Record Size
     D QUSFILBS              861    864i 0
     D*                                             File Buffer Size
     D QUSFILL00             865    870
     D*                                             File Level
     D QUSCFA                871    886
     D*                                             Coded Font Array
     D QUSCM                 887    896
     D*                                             Channel Mode
     D QUSCC1                897    900i 0
     D*                                             Channel Code1
     D QUSCC2                901    904i 0
     D*                                             Channel Code2
     D QUSCC3                905    908i 0
     D*                                             Channel Code3
     D QUSCC4                909    912i 0
     D*                                             Channel Code4
     D QUSCC5                913    916i 0
     D*                                             Channel Code5
     D QUSCC6                917    920i 0
     D*                                             Channel Code6
     D QUSCC7                921    924i 0
     D*                                             Channel Code7
     D QUSCC8                925    928i 0
     D*                                             Channel Code8
     D QUSCC9                929    932i 0
     D*                                             Channel Code9
     D QUSCC10               933    936i 0
     D*                                             Channel Code10
     D QUSCC11               937    940i 0
     D*                                             Channel Code11
     D QUSCC12               941    944i 0
     D*                                             Channel Code12
     D QUSGT                 945    952
     D*                                             Graphics Tokenl
     D QUSRF                 953    962
     D*                                             Record Format
     D QUSRSV103             963    964
     D*                                             Reserved1
     D QUSHD1                965    972P 5
     D*                                             Height Drawer1
     D QUSWD1                973    980P 5
     D*                                             Width Drawer1
     D QUSHD2                981    988P 5
     D*                                             Height Drawer2
     D QUSWD2                989    996P 5
     D*                                             Width Drawer2
     D QUSNBRB               997   1000i 0
     D*                                             Number Buffers
     D QUSMFW               1001   1004i 0
     D*                                             Max Form Width
     D QUSAFW               1005   1008i 0
     D*                                             Alternate Form Width
     D QUSAFL               1009   1012i 0
     D*                                             Alternate Form Length
     D QUSAL                1013   1016i 0
     D*                                             Alternate Lpi
     D QUSTF                1017   1018
     D*                                             Text Flags
     D QUSFFILO             1019   1019
     D*                                             Flg File Open
     D QUSFEPC              1020   1020
     D*                                             Flg Est Pge Cnt
     D QUSFPB               1021   1021
     D*                                             Flg Pge Boundary
     D QUSFT04              1022   1022
     D*                                             Flg Trc
     D QUSFDC               1023   1023
     D*                                             Flg Def Char
     D QUSFC                1024   1024
     D*                                             Flg Cpi
     D QUSFT05              1025   1025
     D*                                             Flg Transparency
     D QUSFDWC              1026   1026
     D*                                             Flg Dbl Wide Char
     D QUSFCR               1027   1027
     D*                                             Flg Char Rotate
     D QUSFCP               1028   1028
     D*                                             Flg Code Page
     D QUSFFE               1029   1029
     D*                                             Flg Fft Emphasis
     D QUSS3812             1030   1030
     D*                                             Flg Scs3812
     D QUSFS                1031   1031
     D*                                             Flg Sld
     D QUSFG                1032   1032
     D*                                             Flg Gea
     D QUSC5219             1033   1033
     D*                                             Flg Cmd5219
     D QUSC3812             1034   1034
     D*                                             Flg Cmd3812
     D QUSFFO               1035   1035
     D*                                             Flg Fld Outline
     D QUSFFFT              1036   1036
     D*                                             Flg Final Frm Txt
     D QUSFB                1037   1037
     D*                                             Flg Barcode
     D QUSFC00              1038   1038
     D*                                             Flg Color
     D QUSFDC00             1039   1039
     D*                                             Flg Drawer Chg
     D QUSFC01              1040   1040
     D*                                             Flg Charid
     D QUSFL                1041   1041
     D*                                             Flg Lpi
     D QUSFF01              1042   1042
     D*                                             Flg Font
     D QUSFH                1043   1043
     D*                                             Flg Highlight
     D QUSFPR               1044   1044
     D*                                             Flg Pge Rotate
     D QUSFS00              1045   1045
     D*                                             Flg Subscript
     D QUSFS01              1046   1046
     D*                                             Flg Superscript
     D QUSFD                1047   1047
     D*                                             Flg Dds
     D QUSFFF               1048   1048
     D*                                             Flg Form Feed
     D QUSFSD               1049   1049
     D*                                             Flg Scs Data
     D QUSFUGD              1050   1050
     D*                                             Flg User Gen Data
     D QUSFG00              1051   1051
     D*                                             Flg Graphics
     D QUSFUD               1052   1052
     D*                                             Flg Unrecogn Data
     D QUSSCIIT             1053   1053
     D*                                             Flg ASCII Trans
     D QUSFIT               1054   1054
     D*                                             Flg Ipds Trans
     D QUSFOV               1055   1055
     D*                                             Flg Office Vis
     D QUSFNL               1056   1056
     D*                                             Flg No Lpi
     D QUSC3353             1057   1057
     D*                                             Flg Cpa3353
     D QUSFSE               1058   1058
     D*                                             Flg Set Excp
     D QUSFCC               1059   1059
     D*                                             Flg Carriage Control
     D QUSFPP               1060   1060
     D*                                             Flg Pge Pos
     D QUSFIC               1061   1061
     D*                                             Flg Invalid Char
     D QUSFL00              1062   1062
     D*                                             Flg Lengths
     D QUSFP5               1063   1063
     D*                                             Flg Pres5a
     D QUSCFLD              1064   1064
     D*                                             Flg Resrvd
     D QUSNFE               1065   1068i 0
     D*                                             Nbr Font Entries
     D QUSNLE               1069   1072i 0
     D*                                             Nbr Lib Entries
     D QUSFE                1073   2225
     D*                                             Font Entries
     D QUSLE                2226   2856
     D*                                             Lib Entries
     D QUSAFPDS             2857   2857
     D*                                             Native AFPDS
     D QUSCHRID             2858   2858
     D*                                             JOBCCSID For CHRID
     D QUSS36CY             2859   2859
     D*                                             S36 Continue Yes
     D QUSDFU               2860   2869
     D*                                             Decimal Format Used
     D QUSDFLA              2870   2876
     D*                                             Date File Last Accessed
     D QUSPG04              2877   2877
     D*                                             Page Groups
     D QUSGLI               2878   2878
     D*                                             Group Level Index
     D QUSPLI               2879   2879
     D*                                             Page Level Index
     D QUSPDSPT             2880   2880
     D*                                             IPDS Pass Through
     D QUSOURL              2881   2884i 0
     D*                                             Off Usr Rsc Libl
     D QUSNURL              2885   2888i 0
     D*                                             Nbr Usr Rsc Libl
     D QUSLURLE             2889   2892i 0
     D*                                             Len Usr Rsc Libl Entry
     D QUSRSV8              2893   2894
     D*                                             Reserved8
     D QUSCS00              2895   2895
     D*                                             Corner Stapling
     D QUSESER              2896   2896
     D*                                             Edge Stitch Edge Ref
     D QUSOFER              2897   2904P 5
     D*                                             Offset From Edge Ref
     D QUSESNS              2905   2908i 0
     D*                                             Edge Stitch Nbr Staples
     D QUSOSP               2909   2912i 0
     D*                                             Offset Staple Positions
     D QUSNOSP              2913   2916i 0
     D*                                             Nbr of Staple Positions
     D QUSLSPE              2917   2920i 0
     D*                                             Len Staple Position Entry
     D QUSFR01              2921   2930
     D*                                             Font Resolution
     D QUSRFNP              2931   2931
     D*                                             Rcd Fmt Name Present
     D QUSSSER              2932   2932
     D*                                             Saddle Stitch Edge Ref
     D QUSSSNS              2933   2936i 0
     D*                                             Saddle Stitch Nbr Staples
     D QUSOSSO              2937   2940i 0
     D*                                             Off Saddle Staple Off
     D QUSNOSSO             2941   2944i 0
     D*                                             Nbr of Saddle Stpl Off
     D QUSLSSOE             2945   2948i 0
     D*                                             Len Saddle Staple Off Entry
     D QUSDSS01             2949   2956P 0
     D*                                             Data Stream Size
     D QUSOSL               2957   2960i 0
     D*                                             Off Splf Libl
     D QUSNOL               2961   2964i 0
     D*                                             Nbr of Libraries
     D QUSLSLE              2965   2968i 0
     D*                                             Len Splf Libl Entry
     D QUSOIPPA02           2969   2972i 0
     D*                                             Off IPP Attrs
     D QUSRSV212            2973   3152
     D*                                             Reserved2
     D QUSFMOD00            3153   3160P 5
     D*                                             Frnt Margin Off Dn
     D QUSFMOA00            3161   3168P 5
     D*                                             Frnt Margin Off Acr
     D QUSBMOD00            3169   3176P 5
     D*                                             Back Margin Off Dn
     D QUSBMOA00            3177   3184P 5
     D*                                             Back Margin Off Acr
     D QUSLOP00             3185   3192P 5
     D*                                             Length Of Page
     D QUSWOP00             3193   3200P 5
     D*                                             Width Of Page
     D QUSMM00              3201   3210
     D*                                             Measure Method
     D QUSAR01              3211   3211
     D*                                             Afp Resource
     D QUSFCS00             3212   3221
     D*                                             Font Char Set
     D QUSFCSL00            3222   3231
     D*                                             Font Char Set Lib
     D QUSCPN00             3232   3241
     D*                                             Code Page Name
     D QUSCPL00             3242   3251
     D*                                             Code Page Lib
     D QUSCFN00             3252   3261
     D*                                             Coded Font Name
     D QUSCFL00             3262   3271
     D*                                             Coded Font Lib
     D QUSCSCFN00           3272   3281
     D*                                             DBCS Coded Font Name
     D QUSCSCFL00           3282   3291
     D*                                             DBCS Coded Font Lib
     D QUSUDFIL00           3292   3301
     D*                                             User Defined File
     D QUSRO00              3302   3311
     D*                                             Reduce Output
     D QUSCBO00             3312   3312
     D*                                             Constant Back Overlay
     D QUSOB00              3313   3316i 0
     D*                                             Output Bin
     D QUSCCSID09           3317   3320i 0
     D*                                             CCSID
     D QUSUT00              3321   3420
     D*                                             User Text
     D QUSOS04              3421   3428
     D*                                             Original System
     D QUSONID00            3429   3436
     D*                                             Original Net ID
     D QUSSC00              3437   3446
     D*                                             Splf Creator
     D QUSRSV503            3447   3448
     D*                                             Reserved5
     D QUSUDOO02            3449   3452i 0
     D*                                             Usr Def Options Offset
     D QUSUDON01            3453   3456i 0
     D*                                             Usr Def Options Number
     D QUSUDOEL00           3457   3460i 0
     D*                                             Usr Def Options Entry Length
     D QUSUDD00             3461   3715
     D*                                             Usr Defined Data
     D QUSUDON02            3716   3725
     D*                                             Usr Def Object Name
     D QUSUDOL00            3726   3735
     D*                                             Usr Def Object Lib
     D QUSUDOT04            3736   3745
     D*                                             Usr Def Object Type
     D QUSRSV601            3746   3748
     D*                                             Reserved6
     D QUSCSPS00            3749   3756P 5
     D*                                             Character Set Point Size
     D QUSCFPS00            3757   3764P 5
     D*                                             Coded Font Point Size
     D QUSSCFPS00           3765   3772P 5
     D*                                             DBCS Coded Font Point Size
     D QUSSFASP00           3773   3776i 0
     D*                                             Spooled File ASP
     D QUSSFILS00           3777   3780i 0
     D*                                             Spooled File Size
     D QUSSSM03             3781   3784i 0
     D*                                             Splf Size Multiplier
     D QUSIPPJI00           3785   3788i 0
     D*                                             IPP JobId
     D QUSSCSM00            3789   3789
     D*                                             Splf Crt Security Method
     D QUSSAM00             3790   3790
     D*                                             Splf Authentication Method
     D QUSWBPD00            3791   3797
     D*                                             Wtr Begin Process Date
     D QUSWBPT00            3798   3803
     D*                                             Wtr Begin Process Time
     D QUSWCPD00            3804   3810
     D*                                             Wtr Complete Proc Date
     D QUSWCPT00            3811   3816
     D*                                             Wtr Complete Proc Time
     D QUSJSN               3817   3824
     D*                                             Job System Name
      **************************************************************************
      * Prototypes
      **************************************************************************
      *
     d SndSplfR        pr
     d  File                         10a
     d  NewSplf                      10a
     d  FullJob                      26a
     d  SplNbr                        5a
     d  ToUser                       10a
      *
     d SndSplfR        pi
     d  File                         10a
     d  NewSplf                      10a
     d  FullJob                      26a
     d  SplNbr                        5a
     d  ToUser                       10a
      *
     d CrtUsrSpc       PR                  ExtPgm('QUSCRTUS')                   Create User Space
     d                               20                                         Qualified Name
     d                               10                                         Extended Attribute
     d                               10i 0                                      Initial Size
     d                                1                                         Initial Value
     d                               10                                         Public Authority
     d                               50                                         Description
     d                               10                                         Replace
     db                                    like(vApiErrDS)
      *
     d SndMsg          PR                  ExtPgm('QMHSNDPM')                   Send Program Message
     d                                7                                         Message ID
     d                               20                                         Message File
     d                            32767                                         Text
     d                               10i 0                                      Length
     d                               10                                         Type
     d                               10                                         Queue
     d                               10i 0                                      Stack Entry
     d                                4                                         Key
     db                                    like(vApiErrDS)
      *
     d RtvMsg          PR                  ExtPgm('QMHRTVM')                    Retrieve Message
     d                              256                                         Message Retrieved
     d                               10i 0                                      Length of Message
     d                                8    const                                Requested format
     d                                7                                         Message ID
     d                               20    const                                Message File
     d                              128                                         Replacement Data
     d                               10i 0 const                                Length of Repl. Data
     d                               10    const                                Substitution Char
     d                               10    const                                Format Control Char
     db                                    like(vApiErrDS)
      *
     d RtvUsrI         PR                  ExtPgm('QSYRUSRI')                   Retrieve User Info
     d                            32767    Options(*varsize)                    Information Retrieve
     d                               10i 0 const                                Length of Info
     d                                8    const                                Requested format
     d                               10                                         User Name
     db                                    like(vApiErrDS)
      *
     d RtvJobI         PR                  ExtPgm('QUSRJOBI')                   Retrieve Job Info
     d                            32767    Options(*varsize)                    Information Retrieve
     d                               10i 0 const                                Length of Info
     d                                8    const                                Requested format
     d                               26                                         Qualified Job Name
     d                               16    const                                Internal Job ID
     db                                    like(vApiErrDS)
      *
     d RtvSplfA        PR                  ExtPgm('QUSRSPLA')                   Retrieve SPLF Attr.
     d                            32767    Options(*varsize)                    Information Retrieve
     d                               10i 0 const                                Length of Info
     d                                8    const                                Requested format
     d                               26                                         Qualified Job Name
     d                               16    const                                Internal Job ID
     d                               16    const                                Internal SPLF ID
     d                               10                                         SPLF name
     d                               10i 0                                      SPLF number
     db                                    like(vApiErrDS)
      *
     d OpnSplf         PR                  ExtPgm('QSPOPNSP')                   Open Spooled File
     d                               10i 0                                      Handle
     d                               26    const                                Qualified Job Name
     d                               16                                         Internal Job ID
     d                               16                                         Internal SPLF ID
     d                               10    const                                SPLF name
     d                               10i 0                                      SPLF number
     d                               10i 0 const                                Number of Buffers
     db                                    like(vApiErrDS)
      *
     d CrtSplf         PR                  ExtPgm('QSPCRTSP')                   Create Spooled File
     d                               10i 0                                      Handle
     d                            32767    Options(*varsize)                    Attributes
     db                                    like(vApiErrDS)
      *
     d GetSplfDta      PR                  ExtPgm('QSPGETSP')                   Get SPLF data
     d                               10i 0                                      Handle
     d                               20                                         User Space Name
     d                                8    const                                Requested Format
     d                               10i 0 const                                Buffer number
     d                               10    const                                End of open file
     db                                    like(vApiErrDS)
      *
     d RtvUsrSpc       PR                  ExtPgm('QUSRTVUS')                   Retrieve User Space
     d                               20                                         User Space Name
     d                               10i 0 const                                Starting Position
     d                               10i 0 const                                Length of Data
     d                               10i 0                                      Number of buffers
      *
     d PutSplfDta      PR                  ExtPgm('QSPPUTSP')                   Put SPLF data
     d                               10i 0                                      Handle
     d                               20                                         User Space Name
     db                                    like(vApiErrDS)
      *
     d ClsSplf         PR                  ExtPgm('QSPCLOSP')                   Close Splf
     d                               10i 0                                      Handle
     db                                    like(vApiErrDS)
      *
     d DltUsrSpc       PR                  ExtPgm('QUSDLTUS')                   Delete User Space
     d                               20                                         Qualified Name
     db                                    like(vApiErrDS)
      *
     d AtoI            PR            10i 0 ExtProc('atoi')                      Alpha to Integer
     d                                 *   value options(*string)
      *
     c
      /free

       // Get job info

       If FullJob = '*';
         Reset vApiErrDs;
         CallP RtvJobI(QUSI0400:
                       %len(qusi0400):
                       'JOBI0400':
                       FullJob:
                       ' ':
                       vApiErrDs);
         If vBytav <> *zeros;
           Exsr ErrorMessage;
         Endif;
         FullJob = QUSJN06 + QUSUN05 + QUSJNBR05;
       Endif;

       // Check to-user

       If ToUser <> '*SAME';
         Reset vApiErrDs;
         CallP RtvUsrI(QSYI0100:
                       %len(qsyi0100):
                       'USRI0100':
                       ToUser:
                       vApiErrDs);
         If vBytav <> *zeros;
           Exsr ErrorMessage;
         Endif;
       Endif;

       // Get Spooled File number

       Select;
         When SplNbr = '*ONLY';
           SpoolNbr = 0;
         When SplNbr = '*LAST';
           SpoolNbr = -1;
         Other;
           SpoolNbr = atoi(%trim(SplNbr));
       Endsl;

       // Get Spooled File attributes

       Reset vApiErrDs;
       CallP RtvSplfA(QUSA0200:
                     %len(qusa0200):
                     'SPLA0200':
                     FullJob:
                     *blanks:
                     *blanks:
                     File:
                     SpoolNbr:
                     vApiErrDs);
       If vBytav <> *zeros;
         Exsr ErrorMessage;
       Endif;

       // Create user space in QTEMP

       Reset vApiErrDs;
       Callp CrtUsrSpc(SpaceName:
                       ExtAttr:
                       InitSize:
                       InitVal:
                       Auth:
                       Text:
                       Replace:
                       vApiErrDs);
       If vBytav <> *zeros;
         Exsr ErrorMessage;
       Endif;

       // Open spooled file

       Reset vApiErrDs;
       Callp OpnSplf(Handle1:
                     '*INT':
                     Qusijid09:
                     Qusisid01:
                     '*INT':
                     Qussnbr00:
                     8:
                     vApiErrDs);
       If vBytav <> *zeros;
         Exsr ErrorMessage;
       Endif;

       // Change attributes + create new spooled file

       If NewSplf <> '*SAME';
         Qussn02 = NewSplf;
       Endif;

       If ToUser <> '*SAME';
         Qusun13 = ToUser;
       Endif;

       Reset vApiErrDs;
       Callp CrtSplf(Handle2:
                     QUSA0200:
                     vApiErrDs);
       If vBytav <> *zeros;
         Exsr ErrorMessage;
       Endif;

       // Get Spooled File Data

       Reset vApiErrDs;
       Dou vBytav <> *zeros;
         Callp GetSplfDta(Handle1:
                        SpaceName:
                        'SPFR0200':
                        -1:
                        '*ERROR':
                        vApiErrDs);
         If vBytav <> *zeros;
           Callp RtvUsrSpc(SpaceName:
                           101:
                           4:
                           BufferReturn);
           If BufferReturn > 8;
              msgmic = 'CPF9898';
              Msgfil = 'QCPFMSG   *LIBL';
              MsgDta = 'The number of buffers returned exceeds the number +
              requested';
              MsgLen = %len(MsgDta);
              Msgtyp = '*ESCAPE';
              Msgstk = 1;
              Msgkey = '    ';

              Reset vApiErrDs;
              Callp SndMsg(msgmic:
                           msgfil:
                           Msgdta:
                           MsgLen:
                           Msgtyp:
                           Msgpgq:
                           Msgstk:
                           Msgkey:
                           vApiErrDs);
              If BufferReturn = *zeros;
                Leave;
              Endif;
            EndOfFile = *on;
           Endif;
         Endif;

       // Put Spooled File Data

       Reset vApiErrDs;
         Callp PutSplfDta(Handle2:
                        SpaceName:
                        vApiErrDs);
         If EndOfFile = *on;
           Leave;
         Endif;
       Enddo;

       // Close spooled files + delete user space

       Reset vApiErrDs;
       Callp ClsSplf(Handle1:
                     vApiErrDs);
       Reset vApiErrDs;
       Callp ClsSplf(Handle2:
                     vApiErrDs);
       Reset vApiErrDs;
       Callp DltUsrSpc(SpaceName:
                       vApiErrDs);

              msgmic = 'CPF9898';
              Msgfil = 'QCPFMSG   *LIBL';
              MsgDta = 'Spooled file ' + %trim(File) + ' sent to user ' +
              %trim(Qusun13);
              MsgLen = %len(MsgDta);
              Msgtyp = '*DIAG';
              Msgpgq = '*CTLBDY';
              Msgstk = 1;
              Msgkey = '    ';

              Reset vApiErrDs;
              Callp SndMsg(msgmic:
                           msgfil:
                           Msgdta:
                           MsgLen:
                           Msgtyp:
                           Msgpgq:
                           Msgstk:
                           Msgkey:
                           vApiErrDs);

       *inlr = *on;
       Return;

       //////////////////////////////
       // ErrorMessage subroutine  //
       //////////////////////////////

       Begsr ErrorMessage;
           CallP RtvMsg(mMsgRtv:
                        mMsgLen:
                        'RTVM0100':
                        vmsgid:
                        'QCPFMSG   *LIBL':
                        vrpldta:
                        %len(vrpldta):
                        '*YES      ':
                        '*NO       ':
                        vApiErrDs);
             If mMsgRtvLen > %len(mMsgMessage);
               mMsgRtvLen = %len(mMsgMessage);
             Endif;

             Msgfil = 'QCPFMSG   *LIBL';
             MsgDta = '0000' + vmsgid + ': ' + %subst(mMsgMessage:1:mMsgRtvLen);
             msgmic = 'CPD0006';
             MsgLen = %len(%trim(MsgDta));
             Msgtyp = '*DIAG';
             Msgpgq = '*CTLBDY';
             Msgstk = 1;
             Msgkey = '    ';

             Reset vApiErrDs;
             Callp SndMsg(msgmic:
                          msgfil:
                          Msgdta:
                          MsgLen:
                          Msgtyp:
                          Msgpgq:
                          Msgstk:
                          Msgkey:
                          vApiErrDs);

             msgmic = 'CPF0006';
             Msgfil = 'QCPFMSG   *LIBL';
             MsgDta =  *blanks;

             MsgLen = %len(MsgDta);
             Msgtyp = '*ESCAPE';
             Msgstk = 1;
             Msgkey = '    ';

             Reset vApiErrDs;
             Callp SndMsg(msgmic:
                          msgfil:
                          Msgdta:
                          MsgLen:
                          Msgtyp:
                          Msgpgq:
                          Msgstk:
                          Msgkey:
                          vApiErrDs);

       Endsr;

      /end-free
